/**
 * @file common/Scheduler.hpp
 * @author The ARTIS Development Team
 * See the AUTHORS or Authors.txt file
 */

/*
 * ARTIS - the multimodeling and simulation environment
 * This file is a part of the ARTIS environment
 *
 * Copyright (C) 2013-2019 ULCO http://www.univ-littoral.fr
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef COMMON_SCHEDULER
#define COMMON_SCHEDULER

#include <artis-star/common/scheduler/HeapScheduler.hpp>
#include <artis-star/common/time/DoubleTime.hpp>

namespace artis {
namespace common {

struct SchedulerHandle;

typedef typename artis::common::scheduler::HeapScheduler<
    common::DoubleTime, SchedulerHandle>::type SchedulerType;

struct SchedulerHandle
{
  SchedulerHandle()
  {}

  SchedulerHandle(const SchedulerType::handle_type &handle)
      : _handle(handle)
  {}

  const SchedulerHandle &handle() const
  { return *this; }

  void handle(const SchedulerHandle &handle)
  { _handle = handle._handle; }

  SchedulerType::handle_type _handle;
};

}
} // namespace artis common

#endif
